#version 330

layout(location = 0) in vec4 position;
layout(location = 1) in vec4 color;
layout(location = 2) in vec4 normal;
layout(location = 3) in vec2 texCoords;

uniform mat4 MVP;
uniform mat4 modelMatrix;
uniform mat4 normalMatrix;
uniform vec4 cameraLocation;
uniform mat4 shadowTransformation;

smooth out vec4 theColor;
out vec3 vertexWorldSpace;
out vec3 vertexNormal;
out vec3 vertexToCam;
out vec2 textureCoords;
out vec4 SM_tex_coord;

void main()
{
	theColor = color;
	gl_Position = MVP * position;

	vertexWorldSpace = (modelMatrix * position).xyz;
	vertexNormal = (normalMatrix * normal).xyz;
	vertexToCam = cameraLocation.xyz - vertexWorldSpace;
	textureCoords = texCoords;

	// shadow texture coords in projected light space
	SM_tex_coord = shadowTransformation * modelMatrix * position;
}
